Subject: Blocking errors if files deleted
Description

If you delete files on the server (without TYPO3) you can get blocking errors as editor.

My specific case was the thumbnails of tt_news in listview. If the connected image does not exist you get an error ('File xyz does not
exist' thrown in LocalDriver) at the whole list-view (instead of a warning). As a limited editor it is almost impossible to fix this error.

I researched and found out that this problem occurs on some places (more or less).

I use TYPO3 6.2beta5.

I'am not sure if it is related to FAL, but i think it is no tt_news-problem.
To reproduce: Create news and link image (i uploaded it initially). Then i used an regular editor backend user. In list view i got this
error.

Related issues:
related to Core - Task # 56147: Regenerate missing RTE magic image on rendering Needs Feedback2014-02-20

Associated revisions
Revision 5869277c - 2014-03-19 08:44 - Frans Saris

[BUGFIX] Catch exception in filelist when file is missing

The code responsible for rendering the thumbs belonging to a
record doesn't catch the exceptions when a file couldn't be found.

This change adds a try catch around the functions that
tries to retrieve the file and displays a flash message when
the file is missing.

Resolves: #56077
Releases: 6.2
Change-Id: Icc6550db43c8738c74fd7ea8faac6e99a54bc0f3
Reviewed-on: https://review.typo3.org/28284
Reviewed-by: Markus Klein
Reviewed-by: Wouter Wolters
Tested-by: Wouter Wolters
Reviewed-by: Georg Ringer
Tested-by: Georg Ringer

2015-08-04 1/3

https://review.typo3.org/28284


History
#1 - 2014-02-20 08:23 - Thomas Sperling

I forgott: For reproducing, you have to delete the file of course.

#2 - 2014-02-22 08:59 - Frans Saris
- Status changed from New to Needs Feedback

For this we added the missing flag feature that is set by the file indexer schedular task.

If you (re)move files direct on filesystem it is recomended to have thuis schedular task run once in a while.

Could you try that and when it still rails post the exception here?

#3 - 2014-02-22 12:38 - Markus Klein

@Frans: Ok, but this is IMO no solution.
What if some person deletes a file and the index regenerated 3 hours later?
In the meantime the BE (and probably other places) is broken.

As a user I'd expect graceful degradation, like a warning somewhere.

#4 - 2014-02-25 18:46 - Markus Klein
- Status changed from Needs Feedback to Accepted

#5 - 2014-02-25 18:51 - Frans Saris

Markus,

During some testing I found out that the missing flag isn't the solution here. So I agree with you that this should be fix.

Gr. Frans

#6 - 2014-03-12 08:44 - Steffen Ritter

@Markus: that is a solution - if you allow anybody (your server, your editor, ftp -whatever) to manage files OUTSIDE the TYPO3 file module you are
obligated to have the indexer task running.

The whole concept of FAL is based on the expectation, that the sys_file table always is sync with the file-system (reliably). This promise needs to be
kept.
Everything which goes wrong because this indexer task is not run frequently enough and changes happened outside TYPO3 - it's not a core fault.

If the missing flag at some places is not enough - than we need to improve the usage of that - of course, but not if it even is not flagged as missing.

#7 - 2014-03-12 09:29 - Frans Saris

Problem is that TYPO3\CMS\Backend\Utility\BackendUtility::thumbCode() doesn't catch the exception. Working on a patch for that now.
#8 - 2014-03-12 09:49 - Gerrit Code Review
- Status changed from Accepted to Under Review

Patch set 1 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/28284

#9 - 2014-03-12 11:46 - Gerrit Code Review

Patch set 2 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/28284

#10 - 2014-03-16 20:18 - Gerrit Code Review

Patch set 3 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/28284

#11 - 2014-03-17 07:40 - Gerrit Code Review

Patch set 4 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/28284

#12 - 2014-03-19 09:30 - Frans Saris
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:5869277c2cb262605ac76c97c6bfe3771fc10fe3.
